<template>
  <div>
    <table class="table" v-if="files.length > 0">
      <thead>
        <tr>
          <th scope="col">Tipo Documento</th>
          <th scope="col">Fecha</th>
          <th scope="col">Archivo</th>
          <th scope="col">Acciones</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(file, index) in props.files" :key="file.id_doc_escan">
          <th scope="row">{{ file.d_tipo_doc_escan }}</th>
          <td>{{ file.f_segu }}</td>
          <td>{{ file.arch_mostrar }}</td>
          <td>
            <button v-if="!data.loading" type="button" class="btn btn-danger btn-sm p-0 ps-1 pe-1" @click="borrar(index, file)"
              title="Eliminar"><i style="font-size:17px;" class="bi bi-trash-fill"></i></button>
            <button v-if="!data.loading" type="button" class="btn btn-info btn-sm ms-1 p-0 ps-1 pe-1" @click="abrir(file)"
              title="Previsualizar"><i style="font-size:17px;" class="bi bi-search"></i></button>
            <button v-if="data.loading" class="btn btn-primary" type="button" disabled>
              <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
              Cargando...
            </button>
          </td>
        </tr>

      </tbody>
    </table>
    <div v-else class="alert alert-secondary" role="alert">
      No hay elementos
    </div>
  </div>
</template>

<script setup lang="ts">
import axios from 'axios';
import { inject, reactive, type PropType } from 'vue';
import { type DocumentsListFile, documentsListKey, sweetalertKey } from "../documentslist";

const emit = defineEmits<{
  (e: "removeElementFromList", elem: number): void,
  (e: "addNotification", elem: string): void,
}>();

const hcdListOptions = inject(documentsListKey);
const swal = inject(sweetalertKey);
const props = defineProps({
    files: {
        type: Array as PropType<DocumentsListFile[]>,
        required: true,
        default: []
    }
});

const data = reactive({
  loading: false as boolean
});

function borrar(index: number, file: DocumentsListFile) {
  swal!.fire({
    title: 'Advertencia',
    text: 'Esta por eliminar un archivo, ¿ Desea continuar ?',
    icon: "warning",
    showCancelButton: true,
    confirmButtonText: 'Eliminar',
    cancelButtonText: "Cancelar",
    confirmButtonColor: "red"
  }).then((result: any) => {
    if (result.isConfirmed) {
      data.loading = true;
      axios.post(hcdListOptions!.base_url + '/escaner/grabarDocEscan', {
        accion: 'B',
        id_doc_escan: file.id_doc_escan
      }).then((response) => {
        if (response.status == 200) {
          axios.post(hcdListOptions!.base_url + "/escaner/deleteFiles", {
            archivos: [file.ruta + '/' + file.arch_mostrar]
          }).then((response) => {
            if (response.status == 200) {
              emit("removeElementFromList", index);
            }
            data.loading = false;
          }).catch((error) => {
            console.log(error);
            emit("addNotification", "Ocurrió un error al intentar borrar el documento del FTP");
            data.loading = false;
          });
        }
        data.loading = false;
      }).catch((error) => {
        console.log(error);
        emit("addNotification", "Ocurrió un error al intentar borrar el documento de la base de datos");
        data.loading = false;
      });
    }
  });
}

function abrir(file: DocumentsListFile) {
  data.loading = true;
  axios.post(hcdListOptions!.base_url + '/escaner/getFileFromFTP', {
    fullPath: file.ruta + '/' + file.arch_mostrar
  }).then(async (response) => {
    var output = "";
    if (response.data.extension == "pdf") {
      var blob = await b64toBlob(response.data.base64File, "application/pdf");
      output = URL.createObjectURL(blob);
      window.open(output);
    } else {
      output = "<img src='data:image/" + response.data.extension + ";base64," + response.data.base64File + "'>";
      let pdfWindow = window.open("");
      pdfWindow!.document.write(output);
    }
    data.loading = false;
  }).catch((error) => {
    console.log(error);
    emit("addNotification", "Ocurrio un error al intentar abrir el documento");
    data.loading = false;
  });
}

async function b64toBlob(b64Data: string, contentType: string = '') {
  const base64Response = await fetch(`data:${contentType};base64,${b64Data}`);
  const blob = await base64Response.blob();
  return blob;
}


defineExpose({
  abrir
});
</script>

<style type="text/scss" lang="scss" scoped></style>
